@ Header file includes.
@c

@<Include our own header files@>@;
@<Include the CCID Card library@>@;

@ Our own header file for this program.
This gives us debug output conditional on the DEBUG preprocessor
variable and the assert statement to check values are correct.
@<Include our...@>=
#include "../share/debug.h"
#include "../share/log.h"

@ The CCID Library headers.
This allows us to talk to the cards via a daemon which is managing access
@<Include the CCID...@>=
#include "../lib/library.h"

@ The main part of the program.
@c
int main(int argc, char** argv)
{
   @<Tester local variables@>@;
   @<Connect to the daemon and request a reference to a card @>;
   @<Send a command to the card@>;
   @<Exit the program@>;
}

@ Connecting to the card.
We make a library call to setup the connection to the daemon and request
access to a card. It returns us a reference to the card we can use to 
send commands to it.

To see if this is a university card we check for the existence of
file ``FD03" and its contents
@<Connect...@>=
   debug("Getting card reference\n");
   assert (get_card_reference(&ref, BLOCK_NEXT_AVAIL, 
           "FD03", "<0-9>{8}<a-z>{2}<0-9>{4}<a-z>0.000") >= 0, "Could not connect");

@ 
@<Tester local variables@>=
   card_ref ref; // a reference to the card we are accessing

@ Sending a command.
Read the card ID from the card.
@<Send...@>=
   debug("Sending command\n");
   apdu_read_binary(ref, 0, 20, carddata, &length);
   carddata[length] = '\0'; // make sure it is null terminated
   printf("The Card ID: %s", carddata); // print it out. Its {\it mostly} ascii
@ 
@<Tester local variables@>=
char* carddata = malloc(21);
int length;

@ Exitting the program.
After connecting and sending a command, we exit the program.
@<Exit...@>=
   release_card(ref);
   free(carddata);
   debug("Exitting");
   return 0;


